#!/usr/bin/python

import socket               # Import socket module
from random import random
import json
import sys

s = socket.socket()         # Create a socket object
host = socket.gethostname() # Get local machine name
port = 54321                # Reserve a port for your service.

s.connect((host, port))
s.send(b"NAME yamyam\n")

actioncount=0
targetx=0
targety=0
myposx=0
myposy=0
found=False

def fixcords(y,x):
	if x<0:
		x=width-1
	if y<0:
		y=height-1
	if x==width:
		x=0
	if y==height:
		y=0

	return y,x

def checkmove(x,y):

	y,x = fixcords(y,x)

	if map[y][x]==-1:
		map[y][x]=actioncount+1
		if yamyam and enemytargetexists:
			if players[y][x]==1:
				targetx=x
				targety=y
				return True, targetx,targety
			else:
				return False, 0,0				
		elif pillexists:
			if points[y][x]==2:
				targetx=x
				targety=y
				return True, targetx,targety
			else:
				return False, 0,0				
		elif points[y][x]>0:
			targetx=x
			targety=y
			return True, targetx,targety
		else:
			return False, 0, 0
	else:
		return False, 0,0


def checkwayback(x,y):

	y,x = fixcords(y,x)

	if map[y][x]<actioncount and map[y][x]>=0:
		return True
	else:
		return False
			
while True:
	line = ""
	characters_to_read=-1
	while (characters_to_read < 0):
     		try:
			data = s.recv(4096)
			characters_to_read = data.index("\n")
			line = line + data[0:characters_to_read]  # removing the newline
		except:
			if data == "":
				print "closed?"
				sys.exit()
			line = line + data
			characters_to_read=-1

	jdata=json.loads(line)

	y=0
	map=[]
	points=[]
	players=[]

	if 'gamestate' in jdata:
		height=jdata['gamestate']['map']['height']
		width=jdata['gamestate']['map']['width']
		pillexists=False
		for item in jdata['gamestate']['map']['content']:
			map.append(list(item))
			points.append(list(item))
			players.append(list(item))
			x=0
			for sign in map[y]:
				if sign == '_' or sign == '-': 
					map[y][x]=-1	#moveable
					points[y][x]=0	#points
				elif sign == '.':
					map[y][x]=-1	#moveable
					points[y][x]=1	#points
				elif sign == 'o':
					pillexists=True
					map[y][x]=-1	#moveable
					points[y][x]=2	#points
				elif sign == '|':
					map[y][x]=-2	#moveable
					points[y][x]=0	#points
				elif sign == '@':
					map[y][x]=-1		#moveable
					points[y][x]=0	#points
				x=x+1

			y=y+1
		
		myposx=jdata['gamestate']['you']['x']
		myposy=jdata['gamestate']['you']['y']
		yamyam=jdata['gamestate']['you']['isdangerous']

		enemytargetexists=False
		for enemy in jdata['gamestate']['others']:
			if enemy['isdangerous']:
				players[enemy['y']][enemy['x']]=2				
				map[enemy['y']][enemy['x']]=-2
			else:
				players[enemy['y']][enemy['x']]=1
				if not yamyam:
					map[enemy['y']][enemy['x']]=-2
				enemytargetexists=True
		
		
		found=False
		map[myposy][myposx]=0
		targetx=myposx
		targety=myposy
		actioncount=0
		while not found and actioncount < 99:
			for y in range(0,height):
				for x in range(0,width):
					if map[y][x]==actioncount:
						if not found:
							found,targetx,targety = checkmove(x,y-1)
						if not found:
							found,targetx,targety = checkmove(x+1,y)
						if not found:
							found,targetx,targety = checkmove(x-1,y)
						if not found:
							found,targetx,targety = checkmove(x,y+1)
						

			actioncount=actioncount+1
			
		if found:
			found = False
			x=targetx
			y=targety
			while not found:
				if checkwayback(x+1,y):
					actioncount=actioncount-1
					map[y][x]='X'
					x = x+1
					y = y
					if actioncount==0:
						found=True
						r=3	
				if not found and checkwayback(x-1,y):
					actioncount=actioncount-1
					map[y][x]='X'
					x = x-1
					y = y
					if actioncount==0:
						found=True
						r=2	
				if not found and checkwayback(x,y+1):
					actioncount=actioncount-1
					map[y][x]='X'
					x = x
					y = y+1
					if actioncount==0:
						found=True
						r=0
				if not found and checkwayback(x,y-1):
					actioncount=actioncount-1
					map[y][x]='X'
					x = x
					y = y-1
					if actioncount==0:
						found=True
						r=1
				y,x = fixcords(y,x)

		else:
			r = int(random() * 4)
	else:
		r = int(random() * 4)
	if (r == 0):
		s.send(b"up\n")
		print "up"
	elif (r == 1):
		s.send(b"down\n")
		print "down"
	elif (r == 2):
		s.send(b"right\n")
		print "right"
	elif (r == 3):
		s.send(b"left\n")
		print "left"
	
s.close                     # Close the socket when done